/*
 * Part of the JavaChan project.
 * (Java ikaChan)
 *
 *        DO WHATEVER YOU WANT TO PUBLIC LICENSE 
 *                    Version 2, December 2004 
 *
 * Modified by gamemanj <asdd2808@gmail.com> to remove expletives
 * Original copyright (C) 2004 Sam Hocevar <sam@hocevar.net> 
 *
 * Everyone is permitted to copy and distribute verbatim or modified 
 * copies of this license document, and changing it is allowed as long 
 * as the name is changed. 
 *
 *            DO WHATEVER YOU WANT TO PUBLIC LICENSE 
 *   TERMS AND CONDITIONS FOR COPYING, DISTRIBUTION AND MODIFICATION 
 *
 *  0. You just DO WHATEVER YOU WANT TO.
 */
package javachan.bosses;

import java.util.Random;
import javachan.GameState;
import javachan.IEventCallback;
import gabien.IGrInDriver;
import gabien.IGrInDriver.IImage;
import javachan.Rect;

/**
 *
 * @author matt
 */
public class IronheadBoss extends BasicBoss {

    public int Health = 15;
    public double VX, VY;
    public boolean Charging = false;

    public IronheadBoss(int ID) {
        super(ID);
        X = 130;
        Y = 90;
    }

    @Override
    public void Hit(GameState gs, int hitironhead, IEventCallback iec, double Time) {
        if (!Battling(gs)) {
            if (gs.LastAnnoyTime < (Time - 2)) {
                gs.LastAnnoyTime = Time;
                iec.StartEvent(1000);
            }
        } else {
            if (!Charging) {
                if (hitironhead == 3) {
                    if (gs.CapacitorTicks > 0) {
                        Health -= 3;
                    } else {
                        Health--;
                    }
                    VY = gs.PlayerVY - 0.1;
                    Y -= 4.0f / 16.0f;
                    if (Health <= 0) {
                        gs.BossMode = false;
                        iec.StartEvent(1001);
                    }
                } else {
                    gs.IkachanXPEnergy(0, -3);
                }
            } else {
                gs.IkachanXPEnergy(0, -3);
            }
        }
    }

    @Override
    public Rect GetRectangle() {
        return new Rect((int) (X * 16), (int) (Y * 16), 64, 24);
    }

    @Override
    public void Draw(int px, int py, GameState gs, IGrInDriver gd) {
        IImage Ironhead = gd.GetImage("Pbm/Ironhead.pbm", 0, 0, 0);
        int charge = (Ironhead.GetHeight() / 4) * 3;
        if (!Charging) {
            charge = 0;
        }
        if (VX <= 0) {
            gd.BlitBCKImage(0, charge, Ironhead.GetWidth() / 4, Ironhead.GetHeight() / 4, ((int) (X * 16) + px), ((int) (Y * 16) + py), Ironhead);
            gd.BlitBCKImage((Ironhead.GetWidth() / 4), 0, Ironhead.GetWidth() / 4, Ironhead.GetHeight() / 4, ((int) (X * 16) + px) + (Ironhead.GetWidth() / 4), ((int) (Y * 16) + py), Ironhead);
        } else {
            gd.BlitBCKImage((Ironhead.GetWidth() / 2), charge, Ironhead.GetWidth() / 4, Ironhead.GetHeight() / 4, ((int) (X * 16) + px) + (Ironhead.GetWidth() / 4), ((int) (Y * 16) + py), Ironhead);
            gd.BlitBCKImage((Ironhead.GetWidth() / 2) + (Ironhead.GetWidth() / 4), 0, Ironhead.GetWidth() / 4, Ironhead.GetHeight() / 4, ((int) (X * 16) + px), ((int) (Y * 16) + py), Ironhead);
        }
    }

    @Override
    public boolean Exists(GameState gs) {
        if (gs.EntityCount < 12) {
            return true;
        }
        return false;
    }

    @Override
    public void Tick(GameState gs) {
        Random r = new Random();

        double IronheadTgtX = 128 + r.nextInt(4);
        double IronheadTgtY = 88 + r.nextInt(4);
        if (Battling(gs)) {
            IronheadTgtX = gs.PlayerX;
            IronheadTgtY = gs.PlayerY;
        }
        IronheadTgtX -= 2;
        //IRONHEAD
        if (Charging) {
            VY = 0;
            if (Math.abs(VX) < 0.05) {
                Charging = false;
            }
            VX *= 0.99;
        } else {
            VX *= 0.98;
            VY *= 0.98;
            if (X > IronheadTgtX) {
                VX -= 0.001;
            }
            if (X < IronheadTgtX) {
                VX += 0.001;
            }
            if (Y > IronheadTgtY) {
                VY -= 0.001;
            }
            if (Y < IronheadTgtY) {
                VY += 0.001;
            }
            if (Battling(gs)) {
                if (new Rect(0, (int) (Y * 16) + 6, 1, 12).intersects(new Rect(0, (int) (gs.PlayerY * 16) - 4, 1, 8))) {
                    if (X > IronheadTgtX) {
                        VX = -0.2;
                    }
                    if (X < IronheadTgtX) {
                        VX = 0.2;
                    }
                    VY = 0;
                    Charging = true;
                }
            }
        }

        X += VX;
        Y += VY;

    }

    @Override
    public void InitBattle() {
        Health=15;
    }
}
