/*
 * Part of the JavaChan project.
 * (Java ikaChan)
 *
 *        DO WHATEVER YOU WANT TO PUBLIC LICENSE 
 *                    Version 2, December 2004 
 *
 * Modified by gamemanj <asdd2808@gmail.com> to remove expletives
 * Original copyright (C) 2004 Sam Hocevar <sam@hocevar.net> 
 *
 * Everyone is permitted to copy and distribute verbatim or modified 
 * copies of this license document, and changing it is allowed as long 
 * as the name is changed. 
 *
 *            DO WHATEVER YOU WANT TO PUBLIC LICENSE 
 *   TERMS AND CONDITIONS FOR COPYING, DISTRIBUTION AND MODIFICATION 
 *
 *  0. You just DO WHATEVER YOU WANT TO.
 */
package javachan.games;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.LinkedList;
import java.util.logging.Level;
import java.util.logging.Logger;
import javachan.Game;
import javachan.IGame;
import gabien.GaBIEn;

/**
 *
 * @author matt
 */
public class EndingGame implements IGame {

    private static class LineObject {
        public String T;
        public double X=0,Y=240;
        public LineObject(String s) {
            T=s;
        }
    }
    public double TimeSinceLastLine=-1.0;
    public BufferedReader FileL;
    public boolean MaruAme,StopWriting=false;
    public LinkedList<LineObject> lines=new LinkedList();
    public IGame targ;
    public double Fadepoint=0;
    public EndingGame(boolean ActuallyMaruAme,IGame target) {
        targ=target;
        MaruAme=ActuallyMaruAme;
        try {
            FileL=new BufferedReader(new InputStreamReader(GaBIEn.GetFile(ActuallyMaruAme?"Words.ptx":"Staff.ptx")));
        } catch (Exception ex) {
            Logger.getLogger(EndingGame.class.getName()).log(Level.SEVERE, null, ex);
        }
            lines.add(new LineObject("<<<IkachanMapEditor Experiment V"+Game.SYSTEM_VERSION+">>>"));
            lines.add(new LineObject("Programmer: gamemanj"));
            lines.getLast().Y+=10;
            lines.add(new LineObject("Please report any bugs to me! ...please?"));
            lines.getLast().Y+=10;
            lines.getLast().Y+=10;
    }

    @Override
    public void Run(double DeltaTime, double Time, Game g) {
        if (g.graphics.IsKeyJustPressed(Keymap.VK_SWIM))
            StopWriting=true;
        for (LineObject lo : lines)
        {
            lo.Y-=DeltaTime*24;
        }
        TimeSinceLastLine+=DeltaTime;
        if ((TimeSinceLastLine>0.5)&&(!StopWriting))
        {
            TimeSinceLastLine-=0.5;
        try {
        while (FileL.ready())
        {
            String p=FileL.readLine();
            if (p.isEmpty()) continue;
            if (p.endsWith("+")) p=p.substring(0,p.length()-1);
            if (p.startsWith("<end"))
            {
                StopWriting=true;
                break;
            }            
            LineObject lo=new LineObject(p);
            lines.add(lo);
            break;
        }
        } catch (IOException ex) {
            Logger.getLogger(EndingGame.class.getName()).log(Level.SEVERE, null, ex);
        }
        }
        g.graphics.Clear(0, 0, 0);
        
        if (MaruAme)
        g.graphics.BlitImage(0, 0, 320, 240, 0, 0, g.graphics.GetImage("Pbm/MaruAme.pbm", 0,0,0));
        if (!MaruAme)
        g.graphics.BlitImage(0, 0, 320, 240, 0, 0, g.graphics.GetImage("Pbm/Staff.pbm", 0,0,0));
        for (LineObject lo : lines)
        {
            int c=255;
            if (MaruAme)
                c=0;
            g.graphics.Display8pxText((int)lo.X, (int)lo.Y, c, c, c,lo.T);
        }
        if (StopWriting)
        {
        Fadepoint+=DeltaTime*16.0;
        if (MainGame.FadeDrawer((int)Fadepoint, true, g.graphics))
        {
            g.music.StopMusic();//make sure Opening doesn't malfunction :)
            g.graphics.ClearKeys();
            g.gamestate=targ;
        }
        }
        g.graphics.Flush();
    }
    
}
