/*
 * Part of the JavaChan project.
 * (Java ikaChan)
 *
 *        DO WHATEVER YOU WANT TO PUBLIC LICENSE 
 *                    Version 2, December 2004 
 *
 * Modified by gamemanj <asdd2808@gmail.com> to remove expletives
 * Original copyright (C) 2004 Sam Hocevar <sam@hocevar.net> 
 *
 * Everyone is permitted to copy and distribute verbatim or modified 
 * copies of this license document, and changing it is allowed as long 
 * as the name is changed. 
 *
 *            DO WHATEVER YOU WANT TO PUBLIC LICENSE 
 *   TERMS AND CONDITIONS FOR COPYING, DISTRIBUTION AND MODIFICATION 
 *
 *  0. You just DO WHATEVER YOU WANT TO.
 */
package javachan.npcs;

import javachan.GameState;
import javachan.GameStateNPChar;
import javachan.GameStateNPChar.NPCCharacter;
import javachan.IEventCallback;
import gabien.IGrInDriver;
import gabien.IGrInDriver.IImage;
import javachan.Rect;

/**
 *
 * @author matt
 */
public class BasicNPCType {
    public Rect GetRectangle(GameStateNPChar.NPCCharacter In)
    {
        return new Rect((int)(In.X*16)+1,(int)(In.Y*16)+1,14,14);
    }
    public void HitWorld(GameStateNPChar.NPCCharacter In,int bdir)
    {
    }
    public boolean HasPhysics()
    {
        return true;
    }
        public String[] NpcImg={
        "AlreadyImplemented","AlreadyImplemented","AlreadyImplemented","AlreadyImplemented","Pbm/Chibi.pbm","AlreadyImplemented","Pbm/Dum.pbm","Pbm/Carry.pbm","Pbm/Juel.pbm","Pbm/Ufo.pbm"
        };
    public void Draw(int px,int py,double Time,GameStateNPChar.NPCCharacter In,GameState gs,IGrInDriver graphics)
        {
            int Type=In.Type;
                IImage npci=graphics.GetImage(NpcImg[Type], 0, 0, 0);
                int xx=0;
                int yy=0;
                int ww=16;
                int hh=16;
                int ox=0;
                int oy=0;
                if (Type==4)
                {
                xx=0;
                yy=0;
                ox=4;
                oy=4;
                ww=8;
                hh=8;
                }
                if (Type==6)
                {
                xx=((int)In.OX)*16;
                }
                if (Type==7)
                {
                xx=0;
                yy=0;
                ww=npci.GetWidth()/2;
                hh=npci.GetHeight()/2;
                ox=8-(ww/2);
                oy=8-(hh/2);
                }
                if (Type==9)
                {
                xx=0;
                yy=0;
                ww=npci.GetWidth();
                hh=npci.GetHeight();
                oy=-(hh/2);
                }
                
                if (npci==null)
                {
                System.out.println("BAD NPCTYPE "+Type);
                } else{
                graphics.BlitBCKImage(xx, yy, ww, hh, (int) (In.X * 16) + px + ox, (int) (In.Y * 16) + py + oy, npci);
                }
            
        }

    public void Tick(NPCCharacter npc, GameState gs, double Time) {
        
    }
    protected void HurtIkachan(GameState gs)
    {
        gs.IkachanXPEnergy(0, -Damage());
    }
    protected void HurtEnemy(GameState gs,NPCCharacter In,IEventCallback iec)
    {
        gs.IkachanXPEnergy(XP(), 0);
        In.Exists=false;
        if (In.CollisionType==2)
        iec.StartEvent(In.EventID);
    }
    //-1:Not needed,0:Left,1:Right,2:Up,3:Down
    
    public void IkachanTouchedEnemy(NPCCharacter In, GameState gs, int r,IEventCallback iec) {
        if (r==3)
        {
            if (gs.PlayerLevel>=LevelToHurt())
            {
               if (gs.HasItem(1))
               {
                   HurtEnemy(gs,In,iec);
               }
            } else {
                //TODO:Sound:Bounced off!
            }
        } else {
            HurtIkachan(gs);
        }
        
    }
    protected int Damage()
    {
        return 0;
    }
    protected int LevelToHurt()
    {
        return 0;
    }
    protected int XP()
    {
        return 0;
    }
}
