/*
 * Part of the JavaChan project.
 * (Java ikaChan)
 *
 *        DO WHATEVER YOU WANT TO PUBLIC LICENSE 
 *                    Version 2, December 2004 
 *
 * Modified by gamemanj <asdd2808@gmail.com> to remove expletives
 * Original copyright (C) 2004 Sam Hocevar <sam@hocevar.net> 
 *
 * Everyone is permitted to copy and distribute verbatim or modified 
 * copies of this license document, and changing it is allowed as long 
 * as the name is changed. 
 *
 *            DO WHATEVER YOU WANT TO PUBLIC LICENSE 
 *   TERMS AND CONDITIONS FOR COPYING, DISTRIBUTION AND MODIFICATION 
 *
 *  0. You just DO WHATEVER YOU WANT TO.
 */
package javachan.npcs;

import javachan.GameState;
import javachan.GameStateNPChar;
import javachan.GameStateNPChar.NPCCharacter;
import javachan.IEventCallback;
import gabien.IGrInDriver;
import gabien.IGrInDriver.IImage;

/**
 *
 * @author matt
 */
public class CrabNPCType extends BasicNPCType {

    @Override
    public boolean HasPhysics() {
        return true;
    }
    
    @Override
    public void Draw(int px,int py,double Time,GameStateNPChar.NPCCharacter In,GameState gs,IGrInDriver graphics)
    {
        int LR = 2;
        if (gs.PlayerX < In.X) {
            LR = 0;
        }
        if (gs.PlayerX > In.X) {
            LR = 1;
        }
        IImage npci=graphics.GetImage("Pbm/Kani.pbm", 0, 0, 0);
        int ox=0;
        int oy=0;
        int ww=16;
        int hh=16;
        int xx=((((int)Math.floor(Time*2.0))&1)==0)?16:0;
        int yy=((In.Status2&1)==1)?16:0;
        if (npci==null)
        {
            System.out.println("MISSING IMAGE FOR ("+getClass().getName()+")");
        } else{
            graphics.BlitBCKImage(xx, yy, ww, hh, (int) (In.X * 16) + px + ox, (int) (In.Y * 16) + py + oy, npci);
        }
    }

    @Override
    public void Tick(NPCCharacter npc, GameState gs, double Time) {
        int LR = 0;
        if (gs.PlayerX < npc.X) {
            LR = -1;
        }
        if (gs.PlayerX > npc.X) {
            LR = 1;
        }
        
        //Important
        double TV=0.05;
        if ((npc.Status2&1)==1)
        {
            if (npc.VY>0)
            {
            npc.Status2^=1;
            npc.Status2^=2;
            ChangeDir(npc);
            }
        } else if ((npc.Status2&2)==2)
        {
            if (npc.OnGround)
            {
                npc.Status2^=2;
                ChangeDir(npc);
            }
        } else {
            if (((npc.Status2>>6)&0x1F)==0)
            {
                if (npc.OnGround)
                {
                ChangeDir(npc);
                npc.Status2^=1;
                npc.Status2|=0x1F<<6;
                npc.VY=-0.15;
                }
            } else {
                npc.Status2-=1<<6;
                
            }
        }
        if ((npc.Status2&(1<<15))==0) npc.VX+=TV/20;
        if ((npc.Status2&(1<<15))==(1<<15)) npc.VX-=TV/20;
        if (npc.VX>TV) npc.VX=TV;
        if (npc.VX<-TV) npc.VX=-TV;
    }
    //must be a power of 2 in length.
    boolean[] movetable=new boolean[] {false,false,true,false,false,false};
    //Yes,I know this is a weird way of doing this.
    private void ChangeDir(NPCCharacter npc) {
        boolean b=movetable[(npc.Status2>>2)&0xF];
        if (b)
        {
            npc.Status2^=1<<15;
        }
        if (((npc.Status2>>2)&0xF)==movetable.length-1)
        {
        npc.Status2^=(movetable.length-1)<<2;
        } else {
        npc.Status2+=1<<2;
        }
    }
    @Override
    public void IkachanTouchedEnemy(NPCCharacter In, GameState gs, int r,IEventCallback iec) {
        if (r==3)
        {
            if (gs.PlayerLevel>=LevelToHurt())
            {
               if (gs.HasItem(1))
               {
                   HurtEnemy(gs,In,iec);
               }
            } else {
                //TODO:Sound:Bounced off!
            }
        }
        if ((In.Status2&1)==1)
        HurtIkachan(gs);
    }
    @Override
    protected int Damage()
    {
        return 2;
    }
    @Override
    protected int LevelToHurt()
    {
        return 2;
    }
    @Override
    protected int XP()
    {
        return 3;
    }
}
